<script lang="ts" setup>
import { Input, Textarea, Alert } from '@distromade/distro-ui';
import { text } from '@distromade/distro-cms';
import { useHead, ref } from '#imports';
import { useThemeContent } from '~/composables';
import * as API from '~/utils/api';
import json from '~/content/contact-us.json';

type Content = typeof json;
type Text = Content['cms']['plainTextElements'];

const { textElements, pageTitle } = await useThemeContent<Text>('/contact-us');

const name = ref<string>('');
const email = ref<string>('');
const contactMessage = ref<string>('');
const contactFormError = ref<string>('');
const sentContact = ref<boolean>(false);

async function submitForm() {
  const message = {
    name: name.value,
    email: email.value,
    message: contactMessage.value,
  };

  const response = await API.sendContact(message);

  if (response.success) {
    // Handle successful response
    console.log('Review submitted successfully:', response.data);
    sentContact.value = true;
  } else {
    if (response?.error?.includes('404')) {
      contactFormError.value = 'Error: Could not submit contact request';
      // Specific handling for 404 error
    }
  }
}

useHead({
  title: () => pageTitle.value,
});
</script>
<template>
  <section class="max-w-form min-h-[600px] m-auto py-20 px-3">
    <Alert v-if="contactFormError" variant="danger" :text="contactFormError" />

    <template v-if="!sentContact">
      <h2 v-html="text(textElements.contactTitle)"></h2>
      <p class="mt-2" v-html="text(textElements.contactDescription)"></p>

      <form class="mt-5" @submit.prevent="submitForm">
        <Input label="Email" v-model="email" name="email" id="email" type="email" required />
        <Input class="mt-4" label="Name" v-model="name" name="name" id="name" required />
        <Textarea
          class="mt-4"
          label="Message"
          v-model="contactMessage"
          name="contact-message"
          id="contact-message"
          required
        />
        <Button
          class="mt-4"
          text="Send message"
          @click.prevent="submitForm"
          variant="primary"
        />
      </form>
    </template>

    <template v-else>
      <h2 v-html="text(textElements.successTitle)"></h2>
      <p class="mt-2" v-html="text(textElements.successDescription)"></p>
    </template>
  </section>
</template>
